#include <bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define dout if(dbg) cout

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pi;
typedef pair<ll, ll> pll;

bool dbg = 0;

ll a[500001];

ll brK[65] = {0}, minDist[65] = {0}; // brKeceva
ll desnoKecevi[65];
ll ksorovi[65];
ll najblizi[500001][64]; // za svaki br, najblizi za setovanje b-tog bita (mzd mogu oba)
bool moguOba[500001] = {0};


vector<ll> minimumi, imajuKsor;

ll mDist(ll a, ll bit, ll ind)
{
    ll prviVeci = a;
    prviVeci |= (1LL << bit);
    if(bit != 0)
        prviVeci -= (a & desnoKecevi[bit-1]);
    dout << "Prvi veci: " << prviVeci << endl;
    ll dist1 = abs(a - prviVeci);
    ll prviManji = a;
    if((1LL << bit) > a)
    {
        najblizi[ind][bit] = prviVeci;
        return dist1;
    }
    if(bit != 0)
        prviManji -= (a & desnoKecevi[bit-1]);
    prviManji--;
    dout << "Prvi manji: " << prviManji << endl;
    ll dist2 = a - prviManji;
    if(dist1 == dist2)
    {
        najblizi[ind][bit] = prviVeci;
        moguOba[ind] = 1;
        return dist1;
    }
    else if(dist1 > dist2)
    {
        najblizi[ind][bit] = prviManji;
        return dist2;
    }
    else
    {
        najblizi[ind][bit] = prviVeci;
        return dist1;
    }
}

int main()
{
    if(!dbg)
    {
        ios::sync_with_stdio(false);
        cin.tie(0);
    }
    desnoKecevi[0] = 1;
    for(ll i = 1; i < 64; i++)
        desnoKecevi[i] = ((1LL << i) + desnoKecevi[i-1]);

    ll n;
    cin >> n;
    ll maksBit = 60;
    for(ll i = 0; i < n; i++) cin >> a[i];

    for(ll b = 0; b <= maksBit; b++)
    {
        for(ll i = 0; i < n; i++)
        {
            najblizi[i][b] = -1;
            moguOba[i] = false;
            bool bit = ((a[i] & (1LL << b)) > 0);
            brK[b] += bit;
            if(i == 0) ksorovi[b] = bit;
            else ksorovi[b] ^= bit;
        }
    }

    bool imaAnd = false, imaXor = false;

    for(ll i = 0; i <= maksBit; i++)
    {
        imaAnd |= (brK[i] == n), imaXor |= ksorovi[i];
        if(ksorovi[i]) imajuKsor.pb(i);
    }


    if(imaAnd && imaXor)
    {
        cout << 0;
        return 0;
    }

    for(ll b = 0; b <= maksBit; b++)
        for(ll i = 0; i < n; i++)
            if((a[i] & (1LL << b)) == 0)
                minDist[b] += mDist(a[i], b, i);

    ll minAnd = (ll)1e18;
    for(ll b = 0; b <= maksBit; b++)
        minAnd = min(minAnd, minDist[b]);

    for(ll b = 0; b <= maksBit; b++)
        if(minDist[b] == minAnd) minimumi.pb(b);


    for(ll b : minimumi)
    {
        for(ll bb = 0; bb <= maksBit; bb++)
        {
            bool ksor;
            for(ll i = 0; i < n; i++)
            {
                if(najblizi[i][b] != -1)
                {
                    if(moguOba[i])
                    {
                        // imamo dva izbora, mozemo nastelovati XOR
                        cout << minAnd;
                        return 0;
                    }
                    else
                    {
                        bool bit = (najblizi[i][b] & (1LL << bb)) > 0;
                        if(i == 0) ksor = bit;
                        else ksor ^= bit;
                    }
                }
                else
                {
                    bool bit = (a[i] & (1LL << bb)) > 0;
                    if(i == 0) ksor = bit;
                    else ksor ^= bit;
                }
            }
            if(ksor == 1)
            {
                cout << minAnd;
                return 0;
            }
        }
    }
    if(minimumi.size() == 1 && minimumi[0] == 0)
    {
        cout << minAnd + 2;
    }
    else
    {
        cout << minAnd + 1;
    }

    return 0;
}